#ifndef SEGMENT_FUNCTIONS_H
#define	SEGMENT_FUNCTIONS_H
//------------------------------------------------------------------------------
#include <string.h>
#include "Segments_Prototypes.h"
#include "../../assets/PCF8575/PCF8575.h"
//------------------------------------------------------------------------------
void Segments_init()
{  
  I2C_init(100000);    // Initialize I2C bus with clock frequency of 100kHz
  Expander_init(0x4E);
}
//------------------------------------------------------------------------------
void Segments_display(signed int number)
{      
  char strNum[10];
  sprintf(strNum,"%4i",number);
  
  for(char pos=0; pos < strlen(strNum); pos++)
  {
    char digit = getDigit(strNum[pos], pos);
    Segments_dataSend(digit, pos);
  }
}
//------------------------------------------------------------------------------
void Segments_dataSend(char data, char col)
{  
  Expander_write(data, 0x01 << col);
  __delay_ms(5);
  Expander_write(data, 0x00); 
}
//------------------------------------------------------------------------------
char getDigit(char asciiChar, char pos)
{
    char digit = 0;
    
    if(asciiChar >= '0' && asciiChar <= '9')
    {
        char i = asciiChar - '0';
        digit = (pos == 2) ? (digits[i] & DECIMAL_POINT) : digits[i]; //ANDing with DECIMAL_POINT Turns off MSB
    }
    else
        if(asciiChar == '-')
        {
            digit = (pos == 2) ? (digits[0] & DECIMAL_POINT) : 0xBF;  //0xBF - minus symbol
        }
        else
            if(asciiChar == ' ')
            {
                digit = (pos == 2) ? (digits[0] & DECIMAL_POINT) : 0xFF; //0xFF - blank. used for leading zero suppression
            }
    
    return digit;
}
//------------------------------------------------------------------------------
#endif